#ifndef __cinvoke_c_h_
#define __cinvoke_c_h_

#ifndef PS
#   define PS(x)     (char *)&(x), sizeof(x)
#endif /* PS */

typedef int cinvoke_bool_t;

typedef enum {
    STDIN_FD = 0,
    STDOUT_FD = 1,
    STDERR_FD = 2,
} unix_std_fds;

#define CINVOKE_FALSE (0)
#define CINVOKE_TRUE (!CINVOKE_FALSE)

#define CINVOKE_MIN(a, b)	(((a) < (b)) ? (a) : (b))
#define CINVOKE_MAX(a, b)	(((a) > (b)) ? (a) : (b))

#define ALIGNED4(x)	(0 == ((x) & 3))

#endif
