from Node import Node

class NamedValueNode(Node):
    node_type = None

    def _repr_fields(self):
        return ['value_name=%r' % (self.value_name,)]
    
    @classmethod
    def size(cls):
        return cls.node_type.size()
    
    @classmethod
    def _pack(cls, value):
        return cls.node_type._pack(value)
    
    @classmethod
    def _unpack(cls, buffer):
        return cls.node_type._unpack(buffer)
    
    def __node(self):
        return self.node_type(self.mbuf, self.environment)
    node = property(__node)

    def __get_value_name(self):
        return self._value_name_of_value(self.value)
    def __set_value_name(self, value_name):
        self.value = self._value_of_value_name(value_name)
    value_name = property(__get_value_name, __set_value_name)

    @classmethod
    def align_size(cls):
        return cls.node_type.align_size()
