#ifndef __cinvoke_request_types_h_
#define __cinvoke_request_types_h_

#include "c.h"

struct cinvoke_server;

typedef enum {
#define REQUEST_TYPE(name) REQUEST_TYPE__##name ,
#include "request_types.x.h"
#undef REQUEST_TYPE
    REQUEST_TYPE_COUNT
} request_type_t;

typedef int (*request_handler_func_t)(struct cinvoke_server *, request_type_t, cinvoke_bool_t accepted);

extern request_handler_func_t cinvoke_server_request_handlers[REQUEST_TYPE_COUNT];

#endif
