#include "server_exports.h"

#include <stdio.h>

cinvoke_server_t cinvoke_stdmain_server;

int main() {
    long result;

    if(0 != cinvoke_server_init(&cinvoke_stdmain_server, STDIN_FD, STDOUT_FD)) {
        fprintf(stderr, "Failure to create a cinvoke server on stdin/stdout");
        return -1;
    }

    if(0 != cinvoke_server_main_loop(&cinvoke_stdmain_server, &result)) {
        fprintf(stderr, "Failure in cinvoke request receive loop");
        return -1;
    }

    cinvoke_server_fini(&cinvoke_stdmain_server);
    
    return result;
}
