#include <stdio.h>
#include <assert.h>
#include <signal.h>
#include <unistd.h>
#include <CInvokeServer/exports.h>

enum e { E_A=0, E_B } e;

union j { int z; } j;

struct Blah {
    int x;
    struct Blah *y;
}
    x = {0, NULL},
    y = {1, &x},
    z = {2, &y};

long print_blah(struct Blah *b, int x, int *y, char *s) {
    int rc;
    long result;
    char data[] = "Data!";
    
    if(NULL == y)
        fprintf(stderr, "Blah: %d, NULL!\n", x);
    else
        fprintf(stderr, "Blah: %d, %d\n", x, *y);
    while(b != NULL) {
        fprintf(stderr, "b->x: %d b->y: %p\n", b->x, b->y);
        b=b->y;
    }

    fprintf(stderr, "\"%s\"\n", s);

    rc = cinvoke_server_loop(&cinvoke_stdmain_server, &result, PS(data));
    assert(0 == rc);

    fprintf(stderr, "\"%s\" and result is %ld\n", s, result);

    return result;
}

void alarm_handler(int c)
{
    long result;
    char data[] = "Alarm!";
    int rc;

    fprintf(stderr, "ALARM!\n");
    rc = cinvoke_server_loop(&cinvoke_stdmain_server, &result, PS(data));
    assert(0 == rc);
}

long reg_signal() {
    int rc;
    struct sigaction sa;
    sa.sa_handler = &alarm_handler;
    sigemptyset(&sa.sa_mask);
    sa.sa_flags = SA_RESTART;
    rc = sigaction(SIGALRM, &sa, NULL);
    assert(0 == rc);

    alarm(5);
    return 0;
}

long test123(long *x, short *y) {
    (*x) = 1;
    (*y) = 2;
    return (*x);
}
