"""Create executable info object for the given executable name.

If you want the results to be cached, don't use the underlying Info modules
directly, but use this module instead."""

from ElfInfo import ElfInfo
from OSUtils import FileUtils

import os

def _exec_info(exec_name):
    # Currently only Elf format is supported.
    return ElfInfo(exec_name)

uncached_exec_info = _exec_info

exec_info = FileUtils.mtime_cache(uncached_exec_info)
